/*------------------------------------------------------------
 XgA CfbNX
------------------------------------------------------------*/
-- f[^x[XuCSItestDBv̍쐬BC:\CSItest tH_[֍쐬
CREATE DATABASE CSItestDB
 ON PRIMARY ( NAME = 'CSItestDB'
			, FILENAME = 'C:\CSItest\CSItestDB.mdf'
			, SIZE = 5120MB )
  LOG ON	( NAME = 'CSItestDB_log'
			, FILENAME = 'C:\CSItest\CSItestDB.ldf'
			, SIZE = 300MB )
go

-- e[uut1v̍쐬
USE CSItestDB
-- DROP TABLE t1
CREATE TABLE t1
 ( a int IDENTITY PRIMARY KEY
 , b int
 , c varchar(3) DEFAULT DATEPART(ms, GETDATE())
 , d char(200) DEFAULT 'dummy1'
 , e char(200) DEFAULT 'dummy2'
 )

-- 10,000,000i1000j̃f[^ǉ
-- f[^̒ǉɂ́A30`2Ԃ܂B
SET NOCOUNT ON
DECLARE @i int = 1, @b int = 1
WHILE @i <= 10000000
 BEGIN
	IF @i % 10000 = 0 SET @b = @i
	INSERT INTO t1(b) VALUES(@b)
	SET @i += 1
 END
SET NOCOUNT OFF

--  10mF
SELECT TOP 100000 * FROM t1 

-- f[^mF
SELECT COUNT(*) FROM t1

-- XgA CfbNX̍쐬
-- DROP INDEX cidx1 ON t1
CREATE NONCLUSTERED COLUMNSTORE INDEX cidx1
 ON t1(a, b, c)
go

-- sv̊mF
SELECT DISTINCT b FROM t1


-- SXL𖾎w
SELECT DISTINCT b FROM t1 WITH(INDEX=0)


-- I/O ƎsԂ̔rBsvO
SET STATISTICS IO ON
SET STATISTICS TIME ON

SELECT DISTINCT b FROM t1 WITH(INDEX=0)			-- SXL
SELECT DISTINCT b FROM t1 WITH(INDEX=cidx1)		-- XgA CfbNX



-- NX^[CfbNX̍쐬
-- DROP INDEX idx_bc ON t1
CREATE NONCLUSTERED INDEX idx_bc
 ON t1(b, c)

-- sv̊mF
SELECT DISTINCT b FROM t1


-- r
SELECT DISTINCT b FROM t1 WITH(INDEX=0)			-- SXL
SELECT DISTINCT b FROM t1 WITH(INDEX=idx_bc)	-- NX^[ Index Scan
SELECT DISTINCT b FROM t1 WITH(INDEX=cidx1)		-- XgA CfbNX


-- f[^obt@LbVNAꍇ
DBCC DROPCLEANBUFFERS
SELECT DISTINCT b FROM t1 WITH(INDEX=0)			-- SXL
DBCC DROPCLEANBUFFERS
SELECT DISTINCT b FROM t1 WITH(INDEX=idx_bc)	-- NX^[ Index Scan
DBCC DROPCLEANBUFFERS
SELECT DISTINCT b FROM t1 WITH(INDEX=cidx1)		-- XgA CfbNX


-- GROUP BY ̏ꍇ
SELECT b, MAX(a) FROM t1 WITH(INDEX=0)			-- SXL
 GROUP BY b
SELECT b, MAX(a) FROM t1 WITH(INDEX=idx_bc)		-- NX^[ Index Scan
 GROUP BY b
SELECT b, MAX(a) FROM t1 WITH(INDEX=cidx1)		-- XgA CfbNX
 GROUP BY b


 -- MAXDOP 1 ̏ꍇ
SELECT b, MAX(a) FROM t1 WITH(INDEX=0)			-- SXL
 GROUP BY b OPTION(MAXDOP 1)
SELECT b, MAX(a) FROM t1 WITH(INDEX=idx_bc)		-- NX^[ Index Scan
 GROUP BY b OPTION(MAXDOP 1)
SELECT b, MAX(a) FROM t1 WITH(INDEX=cidx1)		-- XgA CfbNX
 GROUP BY b OPTION(MAXDOP 1)



 /*
  f[^XV
 */
SET STATISTICS IO OFF
SET STATISTICS TIME OFF

 -- f[^XV
 UPDATE t1
  SET b = 999
   WHERE a = 1


/*
bZ[W 35330Ax 15A 1As 1
UPDATE Xe[ggs܂B
columnstore CfbNX܂ރe[ũf[^XV邱Ƃ͂ł܂B
UPDATE Xe[ggsOɂ columnstore CfbNX𖳌ɂA
UPDATE ̊ɍč\z邱ƂĂB
*/


-- XgA CfbNX̖
ALTER INDEX cidx1
 ON t1
  DISABLE




-- f[^XV
 UPDATE t1
  SET b = 999
   WHERE a = 1

-- mF
SELECT * FROM t1
 WHERE a = 1


-- ̏ꍇ͗płȂ
SELECT b, MAX(a)
 FROM t1 WITH(INDEX=cidx1)
 GROUP BY b

/*
bZ[W 315Ax 16A 1As 1
(FROM Ŏw肳ꂽ) e[u "t1" ̃CfbNX "cidx1" ͖ł邩A
܂̓ICłȂt@C O[vɑ݂Ă܂B
*/


-- XgA CfbNX̗L
ALTER INDEX cidx1
 ON t1
  REBUILD




-- LƂŎsł邱ƂmF
SELECT b, MAX(a)
 FROM t1 WITH(INDEX=cidx1)
 GROUP BY b



/*
 TCY̊mF
*/
-- index_id ̊mF
SELECT index_id, name, * FROM sys.indexes
 WHERE object_id = OBJECT_ID('t1')

-- CfbNX TCY̊mFi[tx̂݁j
SELECT OBJECT_NAME(fg.object_id) AS objName, fg.index_id, i.name as IndexName
	 , fg.page_count, fg.page_count * 8 /1024.0 AS sizeMB
FROM (SELECT * FROM
		sys.dm_db_index_physical_stats ( DB_ID(), NULL, NULL, NULL , 'LIMITED') ) fg
		 INNER JOIN sys.indexes i
			ON fg.object_id = i.object_id AND fg.index_id = i.index_id


-- column_store_segments
SELECT on_disk_size, *
 FROM sys.column_store_segments

-- segments ̍vTCY
SELECT SUM(on_disk_size)
 FROM sys.column_store_segments

-- dictionaries ̍vTCY
SELECT SUM(on_disk_size)
 FROM sys.column_store_dictionaries


